// CADlg.cpp : implementation file
//

#include "stdafx.h"
#include "CACol.h"
#include "CADlg.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//////////////////////////////////////////////////////////////////////////////
// Cellular automata specific functions

COLORREF s[4]={RGB(255,255,255),RGB(255,0,0),RGB(0,128,0),RGB(0,0,255)};

inline BYTE count(COLORREF y1,COLORREF y2,COLORREF y3,COLORREF y4,COLORREF s)
{
	BYTE b=0;
	if (y1==s) b++;
	if (y2==s) b++;
	if (y3==s) b++;
	if (y4==s) b++;
	return b;
}

COLORREF CCADlg::f(COLORREF y, COLORREF yU, COLORREF yUR, COLORREF yR, COLORREF yDR, COLORREF yD, COLORREF yDL, COLORREF yL, COLORREF yUL)
{
	if (y==s[0]) {
		if (count(yU,yR,yD,yL,s[1])==1) return s[2];
		if (count(yU,yR,yD,yL,s[2])==1 || 
			count(yU,yR,yD,yL,s[3])==4) return s[3];
	}
	if (y==s[1]) {
		if (count(yU,yR,yD,yL,s[3])>=1) return s[3];
	}
	if (y==s[2]) {
		if (count(yU,yR,yD,yL,s[3])>=1) return s[3];
	}
	if (y==s[3]) {
		if (count(yU,yR,yD,yL,s[3])>=1) return s[1];
	}
	return y;
}

void CCADlg::init()
{
	for (WORD ww=0; ww<MAXX; ww++) for (WORD wh=0; wh<MAXY; wh++) {
		Field[ww][wh]=s[0];
	}

	Field[170][150]=s[1];
	Field[171][150]=s[1];
	Field[169][150]=s[1];
	Field[170][151]=s[1];
	Field[170][149]=s[1];
}

/////////////////////////////////////////////////////////////////////////////
// CCADlg dialog

CCADlg::CCADlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCADlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCADlg)
	m_bRed = 0;
	m_bGreen = 0;
	m_bBlue = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_bPressed=false;
	m_bDraging=false;
	m_bZoom=1;
	m_wYOffset=0;
	m_wXOffset=0;
	m_brBrush.CreateSolidBrush(RGB(255,0,255));
}

void CCADlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCADlg)
	DDX_Control(pDX, IDC_METRIX, m_sMetrix);
	DDX_Text(pDX, IDC_ERED, m_bRed);
	DDX_Text(pDX, IDC_EGREEN, m_bGreen);
	DDX_Text(pDX, IDC_EBLUE, m_bBlue);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCADlg, CDialog)
	//{{AFX_MSG_MAP(CCADlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_COLOR, OnColor)
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_BN_CLICKED(IDC_STEP, OnStep)
	ON_BN_CLICKED(IDC_RESET, OnReset)
	ON_BN_CLICKED(IDC_AUTO, OnAuto)
	ON_BN_CLICKED(IDC_FILL, OnFill)
	ON_BN_CLICKED(IDC_LOADIMAGE, OnLoadimage)
	ON_BN_CLICKED(IDC_ZOOMPLU, OnZoomplu)
	ON_BN_CLICKED(IDC_ZOOMMIN, OnZoommin)
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCADlg message handlers

BOOL CCADlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// Lets init rectangular workspace
	GetDlgItem(IDC_FIELD)->GetClientRect(m_rField);
	m_wFHeight=m_rField.bottom-5;
	m_wFWidth=m_rField.right-5;

	GetDlgItem(IDC_FIELD)->GetWindowRect(m_rField);
	ScreenToClient(m_rField);
	m_rField.InflateRect(-3,-3);
	m_rField.OffsetRect(-1,-1);

	CString s;
	GetWindowText(s);
	CString str;
	str.Format(" - %dx%d cells",m_wFWidth,m_wFHeight);
	SetWindowText(s+str);

	CClientDC dc(this);
	m_dcField.CreateCompatibleDC(&dc);
	m_bField.CreateCompatibleBitmap(&dc,m_wFWidth,m_wFHeight);
	m_dcField.SelectObject(m_bField);
	m_dcField.FillSolidRect(0,0,m_wFWidth,m_wFHeight,RGB(128,0,128));
	TRACE1("%d\n",m_dcField.GetDeviceCaps(BITSPIXEL));

	CRect rect;
	GetDlgItem(IDC_PROGRESS)->GetWindowRect(rect);
	ScreenToClient(rect);
	m_pProgress.Create(PBS_SMOOTH|WS_CHILD|WS_VISIBLE,rect,this,ID_DYNCREATE);

	OnReset();

	return TRUE;
}

void CCADlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CCADlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this);

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CClientDC dc(this);
		dc.BitBlt(m_rField.left,m_rField.top,m_rField.right-m_rField.left+1,m_rField.bottom-m_rField.top+1,&m_dcField,0,0,SRCCOPY);
		CDialog::OnPaint();
	}
}

HCURSOR CCADlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CCADlg::OnColor() 
{
	UpdateData(TRUE);
	CColorDialog aCDlg(RGB(m_bRed,m_bGreen,m_bBlue),CC_ANYCOLOR|CC_FULLOPEN);

	if (aCDlg.DoModal()) {
		COLORREF crf=aCDlg.GetColor();
		m_bRed=(BYTE)crf;
		m_bGreen=(BYTE)(crf>>8);
		m_bBlue=(BYTE)(crf>>16);
		UpdateData(FALSE);
	}
}

void CCADlg::OnMouseMove(UINT nFlags, CPoint point) 
{
	if (m_rField.PtInRect(point)) {
		CString s;
		s.Format("(%d;%d)",m_wXOffset+(point.x-m_rField.left)/m_bZoom,m_wYOffset+(point.y-m_rField.top)/m_bZoom);
		if (m_bDraging) s="Drag";
		m_sMetrix.SetWindowText(s);
		if (m_bPressed) PutInCell(point);
	} else {
		m_bDraging=FALSE;
		m_bPressed=FALSE;
		m_sMetrix.SetWindowText("(?;?)");
	}

	CDialog::OnMouseMove(nFlags, point);
}

void CCADlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	UpdateData(TRUE);
	m_bPressed=true;
	if (m_rField.PtInRect(point) && m_bPressed) PutInCell(point);
	
	CDialog::OnLButtonDown(nFlags, point);
}

void CCADlg::PaintField()
{
	m_dcField.FillSolidRect(0,0,m_wFWidth,m_wFHeight,RGB(255,255,255));
	WORD width=(WORD)ceil(m_wFWidth/m_bZoom);
	WORD height=(WORD)ceil(m_wFHeight/m_bZoom);
	for (WORD ww=0; ww<width; ww++) {
		m_pProgress.SetPos(2*m_wFWidth+ww*m_bZoom);
		for (WORD wh=0; wh<height; wh++) {
			if (m_bZoom!=1) {
				m_dcField.FillSolidRect(ww*m_bZoom,wh*m_bZoom,m_bZoom,m_bZoom,Field[ww+m_wXOffset][wh+m_wYOffset]);
				if (m_bZoom>5) m_dcField.FrameRect(CRect(ww*m_bZoom,wh*m_bZoom,(ww+1)*m_bZoom+1,(wh+1)*m_bZoom+1),&m_brBrush);
			} else m_dcField.SetPixel(ww,wh,Field[ww+m_wXOffset][wh+m_wYOffset]);
		}
	}
}

void CCADlg::OnLButtonUp(UINT nFlags, CPoint point) 
{
	m_bPressed=false;
	
	CDialog::OnLButtonUp(nFlags, point);
}

UINT MakeStep(LPVOID pParam)
{
	((CCADlg*)pParam)->Step();
	((CCADlg*)pParam)->EnableIt(TRUE);
	return 0;
}

void CCADlg::OnStep() 
{
	EnableIt(FALSE);
	AfxBeginThread(MakeStep,this,THREAD_PRIORITY_ABOVE_NORMAL);
}

void CCADlg::Step() 
{
	WORD ww,wh;

	for (ww=0; ww<m_wFWidth; ww++) {
		m_pProgress.SetPos(ww);
		for (wh=0; wh<m_wFHeight; wh++) {
			Field1[ww][wh]=f(Field[TorItX(ww)][TorItY(wh)],Field[TorItX(ww-1)][TorItY(wh)],Field[TorItX(ww-1)][TorItY(wh+1)],Field[TorItX(ww)][TorItY(wh+1)],Field[TorItX(ww+1)][TorItY(wh+1)],Field[TorItX(ww+1)][TorItY(wh)],Field[TorItX(ww+1)][TorItY(wh-1)],Field[TorItX(ww)][TorItY(wh-1)],Field[TorItX(ww-1)][TorItY(wh-1)]);
		}
	}
	for (ww=0; ww<m_wFWidth; ww++) {
		m_pProgress.SetPos(m_wFWidth+ww);
		for (wh=0; wh<m_wFHeight; wh++) Field[ww][wh]=Field1[ww][wh];
	}
	PaintField();
	Invalidate(FALSE);

	char ch[10];
	itoa(++m_wStep,ch,10);
	GetDlgItem(IDC_STEPNUM)->SetWindowText(ch);

	m_pProgress.SetPos(0);
}

int CCADlg::TorItX(int x)
{
	if (x<0) x+=m_wFWidth;
	if (x>=m_wFWidth) x%=m_wFWidth;
	return x;
	PaintField();
	Invalidate(FALSE);
}

int CCADlg::TorItY(int y)
{
	if (y<0) y+=m_wFHeight;
	if (y>=m_wFHeight) y%=m_wFHeight;
	return y;
}

UINT MakeReset(LPVOID pParam)
{
	((CCADlg*)pParam)->Reset();
	return 0;
}

void CCADlg::OnReset() 
{
	EnableIt(FALSE);
	AfxBeginThread(MakeReset,this,THREAD_PRIORITY_ABOVE_NORMAL);
}

void CCADlg::Reset() 
{
	m_wStep=0;
	m_pProgress.SetRange32(0,m_wFWidth*3);
	init();
	PaintField();
	Invalidate(FALSE);

	GetDlgItem(IDC_STEPNUM)->SetWindowText("0");

	m_pProgress.SetPos(0);
	EnableIt(TRUE);
}

void CCADlg::EnableIt(BOOL b,BOOL IsAuto)
{
	GetDlgItem(IDC_STEP)->EnableWindow(b);
	GetDlgItem(IDC_RESET)->EnableWindow(b);
	GetDlgItem(IDC_LOADIMAGE)->EnableWindow(b);
	GetDlgItem(IDC_ZOOMPLU)->EnableWindow(b);
	GetDlgItem(IDC_ZOOMMIN)->EnableWindow(b);
	GetDlgItem(IDC_FILL)->EnableWindow(b);
	GetDlgItem(IDC_ERED)->EnableWindow(b);
	GetDlgItem(IDC_EGREEN)->EnableWindow(b);
	GetDlgItem(IDC_EBLUE)->EnableWindow(b);
	GetDlgItem(IDC_COLOR)->EnableWindow(b);
	if (!IsAuto) GetDlgItem(IDC_AUTO)->EnableWindow(b);
}

UINT MakeAuto(LPVOID pParam)
{
	CCADlg* dlg=(CCADlg*)pParam;
	while (((CButton*)dlg->GetDlgItem(IDC_AUTO))->GetCheck()) dlg->Step();
	dlg->EnableIt(TRUE,FALSE);
	return 0;
}

void CCADlg::OnAuto() 
{
	if (((CButton*)GetDlgItem(IDC_AUTO))->GetCheck()) {
		EnableIt(FALSE,TRUE);
		AfxBeginThread(MakeAuto,this,THREAD_PRIORITY_ABOVE_NORMAL);
	} else GetDlgItem(IDC_AUTO)->EnableWindow(FALSE);
}

void CCADlg::OnFill() 
{
	UpdateData(TRUE);
	COLORREF c=RGB(m_bRed,m_bGreen,m_bBlue);
	for (WORD ww=0; ww<MAXX; ww++) for (WORD wh=0; wh<MAXY; wh++) Field[ww][wh]=c;
	PaintField();
	Invalidate(FALSE);
	m_pProgress.SetPos(0);
}

void CCADlg::OnZoomplu() 
{
	m_bZoom++;
	if (m_bZoom>MAXZOOM) m_bZoom=MAXZOOM; else {
		TestOffsets();
		CString s;
		s.Format("x%d",m_bZoom);
		GetDlgItem(IDC_ZOOM)->SetWindowText(s);

		PaintField();
		Invalidate(FALSE);
		m_pProgress.SetPos(0);
	}
}

void CCADlg::OnZoommin() 
{
	m_bZoom--;
	if (m_bZoom<1) m_bZoom=1; else {
		TestOffsets();
		CString s;
		s.Format("x%d",m_bZoom);
		GetDlgItem(IDC_ZOOM)->SetWindowText(s);

		PaintField();
		Invalidate(FALSE);
		m_pProgress.SetPos(0);
	}
}

void CCADlg::PutInCell(CPoint point)
{
	WORD ww=(point.x-m_rField.left)/m_bZoom;
	WORD wh=(point.y-m_rField.top)/m_bZoom;
	Field[m_wXOffset+ww][m_wYOffset+wh]=RGB(m_bRed,m_bGreen,m_bBlue);
	if (m_bZoom!=1) {
		m_dcField.FillSolidRect(ww*m_bZoom,wh*m_bZoom,m_bZoom,m_bZoom,RGB(m_bRed,m_bGreen,m_bBlue));
		if (m_bZoom>5) m_dcField.FrameRect(CRect(ww*m_bZoom,wh*m_bZoom,(ww+1)*m_bZoom+1,(wh+1)*m_bZoom+1),&m_brBrush);
	} else m_dcField.SetPixel(ww,wh,RGB(m_bRed,m_bGreen,m_bBlue));
	Invalidate(FALSE);
}

void CCADlg::OnRButtonDown(UINT nFlags, CPoint point) 
{
	m_bDraging=TRUE;
	m_pntPrev=point;

	CDialog::OnRButtonDown(nFlags, point);
}

void CCADlg::OnRButtonUp(UINT nFlags, CPoint point) 
{
	m_bDraging=FALSE;

	m_wXOffset+=(m_pntPrev.x-point.x)/m_bZoom;
	m_wYOffset+=(m_pntPrev.y-point.y)/m_bZoom;

	TestOffsets();

	PaintField();
	Invalidate(FALSE);
	m_pProgress.SetPos(0);
	
	CDialog::OnRButtonUp(nFlags, point);
}

void CCADlg::TestOffsets()
{
	WORD width=(WORD)ceil(m_wFWidth/m_bZoom);
	WORD height=(WORD)ceil(m_wFHeight/m_bZoom);

	if (m_wXOffset<0) m_wXOffset=0;
	if (m_wXOffset>m_wFWidth-width) m_wXOffset=m_wFWidth-width;
	if (m_wYOffset<0) m_wYOffset=0;
	if (m_wYOffset>m_wFHeight-height) m_wYOffset=m_wFHeight-height;
}

void CCADlg::OnLoadimage() 
{
	CFileDialog od(TRUE);

	if (od.DoModal()) {
		HBITMAP hbmp=(HBITMAP)LoadImage(0,od.GetPathName(),IMAGE_BITMAP,0,0,LR_LOADFROMFILE);

		CBitmap* bmp;
		bmp=CBitmap::FromHandle(hbmp);

		CClientDC cdc(this);
		CDC dc; 
		dc.CreateCompatibleDC(&cdc);
		dc.SelectObject(bmp);

		BITMAP bitmap;
		bmp->GetBitmap(&bitmap);

		int ox=(m_wFWidth-bitmap.bmWidth)/2;
		int oy=(m_wFHeight-bitmap.bmHeight)/2;

		for (int i=0;i<bitmap.bmWidth;i++) for (int j=0;j<bitmap.bmHeight;j++) Field[i+ox][j+oy]=dc.GetPixel(i,j);

		PaintField();
		Invalidate(FALSE);
		m_pProgress.SetPos(0);
	}
}
